con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000  
  RX_PIN        =  30
  TX_PIN        =  31
  MODE          = %0000                                 ' see FullDuplexSerial.spin for description
  BAUD          = 9600
  pin           = 15
  i2cSCL        = 18
  i2cSDA        = 29
  devSel        = $7000
  num           = 63
  PAGESIZE = 32 
obj
  com   :      "FullDuplexDebug"
  i2c      : "i2cObject"
var
  byte buffer[PAGESIZE*2]
  long eepromAddress
  byte  input_str[64]  
pub Main  | i, c   
  com.start(TX_PIN,RX_PIN,%0000,9600)
  eepromAddress := $0000                       
  flash
pub flash | total, page, idx, j, start_time
    com.rx
    repeat j from 0 to constant(($8000/PAGESIZE)-1)
      repeat page from 0 to num
         buffer[page]:=com.rx
      com.rxflush
      i2c.WritePage(i2c#BootPin, i2c#EEPROM, (j*PAGESIZE), @buffer, PAGESIZE)
      start_time := cnt ' prepare to check for a timeout
      repeat while i2c.WriteWait(i2c#BootPin, i2c#EEPROM, (j*PAGESIZE))
        if cnt - start_time > clkfreq / 10
          quit
      readit
      eepromAddress := eepromAddress + 32
      repeat page from 0 to num step 2
        com.tx(buffer[page])
        com.tx(buffer[page+1])
      com.str(string("endofstring"))   
      com.rxflush 
PRI readIt
   if i2c.ReadPage(i2c#BootPin, i2c#EEPROM, eepromAddress, @buffer, 32)
     abort ' an error occurred during the read


              